var cqrPageSelection = "";
var cqrPageURL = "";
var cqrPageHost = "";
var cqrLinkURL = "";
var cqrImgName = "";
var cqrImgURL = "";

var cqrAction = "";
var cqrActionPrompt = "";
var cqrConfigLastWillId = "";
var cqrConfigLastWillCtrl = false;
var cqrTabRef = "";
var cqrWndRef = "";
if (cqrMailFlag){
    var browser = getMessageBrowser();
}else{
    var browser = getBrowser();
}

/// HotMenu. Many thanks to Henrik Gulbrandsen for developing this!
function RegisterContextMenuListener(){
  browser.addEventListener("contextmenu", HandleContextMenu, true);
}

function HandleInsertedNode(event){
// somehow this sub breaks up the top menu ("File", "Edit" e.t.c) of Mozilla 1.7a, bild 2004010508
// ...and somehow HotMenu works without this :))
//  if (event.target.id == "content"){
//    RegisterContextMenuListener();
//  } 
}

document.addEventListener("DOMNodeInserted", HandleInsertedNode, false);
RegisterContextMenuListener();

function HandleContextMenu(event){
  cqrLinkURL = findParentNode(event.originalTarget, "a");
  cqrImgObj = findParentNode(event.originalTarget, "img");
  if (cqrImgObj){
    cqrImgURL = cqrAbsURI(cqrImgObj.baseURI, cqrImgObj.src);
    cqrImgName = getFNameFromURI(cqrImgURL);
  }
  if (!cqrLinkURL) {cqrLinkURL = ""}
  
  //Strange bug in Thunderbird: when passing event.shiftKey to another function, that function
  //actually gets not boolean value as expected, but whole event object. Have no time to play with this, so:
  var kShift = "";
  if (event.shiftKey || event.ctrlKey ){kShift = "yes"}
  //kShift = event.shiftKey;
  
  prfs_LoadMain();
  if ((kShift) && (cqrUseHotMenu)){
    //var box = getBrowser().boxObject;
    var box = browser.boxObject;
    MouseX = event.screenX - box.screenX + box.x;
    MouseY = event.screenY - box.screenY + box.y;

    document.popupNode = event.target;
    event.preventDefault();
    hotmenu(kShift, MouseX, MouseY);
  } else {
    //FillMenu(kShift)
  }
}

function hotmenu(kShift, x, y){
try{
  var hotmenu = window.document.getElementById("cq-hotmenu");
  if (!hotmenu) {
    hotmenu = window.document.createElement("menupopup");
    hotmenu.id = "cq-hotmenu";
    window.document.documentElement.appendChild(hotmenu);
  }
  hotmenu.setAttribute("position", "at_pointer"); //at_pointer
  FillMenu(kShift, "");
  if (cqrMailFlag){
    var offx = -210;
    var offy = -260;
  } else {
    var offx = 2;
    var offy = 2;
  }    
  //hotmenu.showPopup(browser, MouseX + offx, MouseY + offy, "context", "bottomleft", "topleft");
  hotmenu.showPopup(browser, x, y, "context", "", "");
}catch(er){cqerr(er, "hotmenu sub")}
}


function FillMenu(kShift, allshowif){
try{
  prfs_LoadMain();
  lastDirState = rdir(cqrPlugsDir);
  getPageParams();
  if (srcupdated()) {
  	plg_QuickLoadAll();
  }
  prfs_UpdateEntries();
  doc = window.document;
  var recommend = [];
  
  var ppMenu = doc.getElementById("cq-ppm");

  if ((kShift) && (cqrUseHotMenu)) {
    ppMenu = doc.getElementById("cq-hotmenu");
  }
  while (ppMenu.hasChildNodes()) {ppMenu.removeChild(ppMenu.lastChild)}
  var entries = EntryHash._Items();
  for (entry in entries){
    if (entries[entry].blocked) continue;
	  if (entries[entry].Context){
		  var ppItem = doc.createElement("menuitem");
		  ppItem.setAttribute("class", "menuitem-iconic");
	      if (!entries[entry].iconpath){
	        if (cqrHTTPIcon){
	            icourl = url2host(entries[entry].Action);
	            if (icourl) {ppItem.setAttribute("image", icourl + "/favicon.ico")};
	        }
	      }else{
	        ppItem.setAttribute("image", "file://" + entries[entry].iconpath);
	      }
		  ppItem.setAttribute("label", "   " + entries[entry].Title);
		  ppItem.setAttribute("tooltiptext", cqrMess.GetStringFromName('cqr.menu.plgToolTip'));
		  ppItem.setAttribute("oncommand", "ProcessEntry(event.ctrlKey, '"+entries[entry].eId+"')");
		  ppMenu.appendChild(ppItem);
		}//else{
	  if (entries[entry].showif){
	    re = new RegExp(entries[entry].showif,"im");
	    trg = SubstVars(entries[entry].sitarget, entries[entry]);
	    //res = re.exec(cqrPageSelection);
	    res = re.exec(trg);
	    if (res || allshowif){
	      EntryHash[entries[entry].eId].lastmatch = res;
  	    if (!entries[entry].Context) recommend[entry]="";
	    } else {
	      EntryHash[entries[entry].eId].lastmatch = [];
	      EntryHash[entries[entry].eId].lastmatch[0] = trg;
	    }
		}
//		}
  }
  if (recommend.length){
    ppMenu.appendChild(doc.createElement("menuseparator"));
    for (each in recommend){
  	  var ppItem = doc.createElement("menuitem");
	  ppItem.setAttribute("class", "menuitem-iconic");
      if (!entries[each].iconpath){
        if (cqrHTTPIcon){
            icourl = url2host(entries[each].Action);
            if (icourl) {ppItem.setAttribute("image", icourl + "/favicon.ico")};
        }
      }else{
        ppItem.setAttribute("image", "file://" + entries[each].iconpath);
      }
  	  ppItem.setAttribute("label", entries[each].Title);
  	  ppItem.setAttribute("tooltiptext", cqrMess.GetStringFromName('cqr.menu.plgToolTip'));
  	  ppItem.setAttribute("oncommand", "ProcessEntry(event.ctrlKey, '"+entries[each].eId+"')");
  	  ppMenu.appendChild(ppItem);
    }
  }

lastDirState = null;
ppMenu = null;
ppItem = null;
entries = null;

}catch(er){cqerr(er, "FillMenu sub")}
}

function detecttrg(evnt){
 if (evnt.originalTarget.localName == "menuseparator") FillMenu(false,true);
}

function ProcessEntry(ctrl, EntryId){
	//getPageParams();
	var entry = EntryHash._Item(EntryId);
	if (ctrl) cqrShowAlternatives = true;
	//if plugin not loaded - load it
	if (!entry.Inputs){
		entry = plg_ReadData(entry.filepath);
        entry.Context = EntryHash[EntryId].Context;
        entry.lastmatch = EntryHash[EntryId].lastmatch;
		EntryHash._AddEntryObj(entry, entry.eId);
	}
  PrepareAction(entry);
	if (cqrcancel){
		resetenv();
		return;
	}

  if (cqrMailFlag){
    //doc = window.document;
    try{
      if (entry.Action){
        var cqrurl = cqrAction;
      } else {
        var cqrurl = entry.Action;
      }
      firstpass = true;
      for (each in QueryHash){
          if (firstpass){
            cqrurl = cqrurl + "?" + each + "=" + QueryHash[each];
            firstpass = false;
          } else {
            cqrurl = cqrurl + "&" + each + "=" + QueryHash[each];
          }
      }
      var mess = Components.classes["@mozilla.org/messenger;1"].getService(Components.interfaces.nsIMessenger);
      mess.launchExternalURL(cqrurl);
      resetenv();
      return;
    }catch(er){cqerr(er, "ProcessEntry sub (mail)")}
  }


  //var browser = getBrowser();
  if ((cqrAction) && (!entry.Inputs)){
    if (cqrOpenRes != "win_fg") {
        tab = browser.addTab(cqrAction);
        if (cqrOpenRes == "tab_fg") browser.selectedTab = tab;
     } else {
        window.open(cqrAction);
     }
     resetenv();
     return;
  }

  if ((cqrOpenRes == "win_fg") || (cqrOpenRes == "win_bg")) {
      myTabRef = window.open();
      if (cqrOpenRes == "win_bg") window.focus();
   } else {
      myTabRef = browser.addTab();
      if (cqrOpenRes == "tab_fg") browser.selectedTab = myTabRef;
   }
  window.setTimeout('formIt("'+ EntryId + '");', 70);
}

function formIt(EntryId){
var entry = EntryHash._Item(EntryId);
    if ((cqrOpenRes == "win_fg") || (cqrOpenRes == "win_bg")) {
        doc = myTabRef.document;
    } else {
        tabBr = getBrowser().getBrowserForTab(myTabRef);
        doc = tabBr.contentDocument;
    }

    try{
      var frm = doc.createElementNS("http://www.w3.org/1999/xhtml", "form");
      frm.setAttribute("name", "cqrform");
      if (entry.Action){
        frm.setAttribute("action", cqrAction);
      } else {
        frm.setAttribute("action", entry.Action);
      }
      frm.setAttribute("method", entry.Method);
      frm.setAttribute("style", "display: none;");
      frm.setAttribute("accept-charset", entry.qcharset);
      if (cqrMailFlag) frm.setAttribute("target", "_blank");
      for (each in QueryHash){
        var inp = doc.createElementNS("http://www.w3.org/1999/xhtml", "input");
          inp.setAttribute("type", "hidden");
          inp.setAttribute("name", each);
          inp.setAttribute("value", QueryHash[each]);
          frm.appendChild(inp);
      }
      doc.documentElement.appendChild(frm);
      frm.submit();
      resetenv();
    } catch(er){cqerr(er, "ProcessEntry sub")}
}

function PrepareAction(EntryObj){
try{
  cqrAction = SubstVars(EntryObj.Action, EntryObj);
  for (i in EntryObj.Inputs){
    QueryHash[EntryObj.Inputs[i].def.name] = SubstVars(EntryObj.Inputs[i].def.value, EntryObj);
  }
  if (cqrShowAlternatives) window.openDialog("chrome://conquery/content/list.xul","_blank", "centerscreen,chrome,modal,resizable=yes", EntryObj);
}catch(er){cqerr(er, "PrepareAction sub")}
}

function SubstVars(str, EntryObj){
    var retstr = "";
    ire = new RegExp("\\[:(\\w+)(:(\\d*))?\\]", "ig");
    cqrvars = ire.exec(str);
    lastind = 0;
    if (cqrvars){
      while (cqrvars){
        tmpstr = str.substring(lastind, ire.lastIndex);
        switch("[:"+cqrvars[1]+"]"){
          case "[:selection]":
            if (!cqrPageSelection) cqrShowAlternatives=true;
            retstr += tmpstr.replace("[:selection]", cqrPageSelection);
            break;
          case "[:url]":
            retstr += tmpstr.replace("[:url]", cqrPageURL);
            break;
          case "[:linkurl]":
            retstr += tmpstr.replace("[:linkurl]", cqrLinkURL);
            break;
          case "[:imgurl]":
            retstr += tmpstr.replace("[:imgurl]", cqrImgURL);
            break;
          case "[:imgname]":
            retstr += tmpstr.replace("[:imgname]", cqrImgName);
            break;
          case "[:host]":
            retstr += tmpstr.replace("[:host]", cqrPageHost);
            break;
          case "[:text]":
            retstr += tmpstr.replace("[:text]", "");
            break;
          case "[:matched]":
            var matchnum = Number(cqrvars[3]);
            if (isNaN(matchnum)) matchnum = 0;
            if (EntryObj.lastmatch[matchnum]){
              retstr += tmpstr.replace(cqrvars[0], EntryObj.lastmatch[matchnum]);
            }else{
              retstr += tmpstr.replace(cqrvars[0], "");
            }
            break;
          case "[:prompt]":
            cqrShowAlternatives=true;
            retstr += tmpstr.replace("[:prompt]", "");
            break;
          //if variable is not recognized
          default:
            retstr += tmpstr;
        }
      //ire.lastIndex = 0;
      lastind = ire.lastIndex;
      cqrvars = ire.exec(str);
      }
      retstr += str.substring(lastind);
    } else {retstr = str}
    return retstr;
}

function OpenCfgDialog(){
	window.openDialog("chrome://conquery/content/conquery-pref.xul", cqrMess.GetStringFromName('cqr.cfg.wTitle'), "centerscreen,chrome,modal,resizable=yes");
  if (cqrConfigLastWillId){
    ProcessEntry(cqrConfigLastWillCtrl, cqrConfigLastWillId);
    cqrConfigLastWillId = "";
  }
}

function getPageParams(){
	try{
		var focusedWindow = document.commandDispatcher.focusedWindow;
		cqrPageSelection = String(focusedWindow.__proto__.getSelection.call(focusedWindow));
	}catch(er){cqrPageSelection=""}
  
  try{
  	cqrPageURL = focusedWindow.location.href;
	}catch(er){cqrPageURL=""}
	
	try{
	  	cqrPageHost = focusedWindow.location.host;
	}catch(er){cqrPageHost=""}
}

function resetenv(){
	QueryHash = new Object();
	cqrPageSelection = "";
	cqrPageURL = "";
	cqrPageHost = "";
	cqrLinkURL = "";
	cqrImgName = "";
	cqrImgURL = "";
	cqrAction = "";
	cqrConfigLastWillId = "";
	cqrConfigLastWillCtrl = false;
	cqrShowAlternatives = false;
	cqrcancel = false;
	cqrTabRef = "";
	cqrWndRef = "";
}
